【leetcode】 跳跃游戏 IV

跳跃游戏IV

题目

复制代码
给你一个整数数组 arr ,你一开始在数组的第一个元素处(下标为 0)。

每一步,你可以从下标 i 跳到下标 i + 1 、i - 1 或者 j :

i + 1 需满足:i + 1 < arr.length
i - 1 需满足:i - 1 >= 0
j 需满足:arr[i] == arr[j] 且 i != j
请你返回到达数组最后一个元素的下标处所需的 最少操作次数 。

注意:任何时候你都不能跳到数组外面。

 

示例 1:

输入:arr = [100,-23,-23,404,100,23,23,23,3,404]
输出:3
解释:那你需要跳跃 3 次,下标依次为 0 --> 4 --> 3 --> 9 。下标 9 为数组的最后一个元素的下标。
示例 2:

输入:arr = [7]
输出:0
解释:一开始就在最后一个元素处,所以你不需要跳跃。
示例 3:

输入:arr = [7,6,9,6,9,6,9,7]
输出:1
解释:你可以直接从下标 0 处跳到下标 7 处,也就是数组的最后一个元素处。
 

提示:

1 <= arr.length <= 5 * 104
-108 <= arr[i] <= 108

思路

  • 拿到题的第一反应 是使用动态规划的方式进行接替
    即dpi表示第i个位置到达数组最后一个元素需要操作最少的步骤
    dp[i] = min(dp[i - 1] + 1, dp[i + 1] + 1, dp[j] + 1),其中arr[i] == arr[j] && i != j
    尝试了好久有一个用例一直无法通过,后来思考了一下 发现dp[i]的结果依赖于dp[i + 1],而dp[i + 1]的结果也依赖dp[i],在这种情况下无法使用动态规划解题(想到这点的时候还没意识到)。后来看了题解里大佬论证dp不可行的原因才意识到。
  • 采用BFS + 剪枝,看代码吧。
  • 一开始确实是用了map进行剪枝,但是剪枝后没remove掉导致有个用例超时,这里记录一下吸取教训。

代码

java 复制代码
    public int minJumps(int[] arr) {
        if (arr.length == 1) {
            return 0;
        }

        Map<Integer, List<Integer>> firstMap = new HashMap<>();

        for (int i = 0; i < arr.length; ++i) {
            int val = arr[i];
            if (!firstMap.containsKey(val)) {
                firstMap.put(val, new ArrayList<>());
            }
            firstMap.get(val).add(i);
        }

        Queue<Integer> idxQueue = new LinkedList<>();
        Set<Integer> visited = new HashSet<>();

        idxQueue.offer(0);
        visited.add(0);
        int step = 0;

        while (!idxQueue.isEmpty()) {
            int size = idxQueue.size();
            for (int k = 0; k < size; ++k) {
                int idx = idxQueue.poll();

                if (idx == arr.length - 1) {
                    return step;
                }

                if(idx - 1 >= 0 && !visited.contains(idx - 1)) {
                    idxQueue.offer(idx - 1);
                    visited.add(idx - 1);
                }


                if(idx + 1 < arr.length && !visited.contains(idx + 1)) {
                    idxQueue.offer(idx + 1);
                    visited.add(idx + 1);
                }

                // 跳着走
                if (firstMap.containsKey(arr[idx])) {
                    for (int i : firstMap.get(arr[idx])) {
                        if (arr[i] == arr[idx] && i != idx && !visited.contains(i)) {
                            idxQueue.offer(i);
                            visited.add(i);
                        }
                    }
                    firstMap.remove(arr[idx]);
                }

            }
            ++step;
        }
        return step;
    }
相关推荐
Pniubi6 小时前
HashMap的扩容和树化边界
java·开发语言
Mikko76 小时前
用 Java 复刻了高中时在塞班上玩的「熔岩矿车」:纯 Swing、零依赖、没有一张图片,一个 jar 双击就能玩
java·游戏开发·swing
知了学历孙老师6 小时前
小自考的校考和统考,出题方和难度差在哪
java·大数据·前端
Java爱好狂.7 小时前
Java初学者如何一周速通SpringBoot!
java·spring boot·后端·spring·高并发·架构师·java面试
秋饼7 小时前
LLM API密钥动态轮换实战:Spring Vault + Spring AI + 多Provider路由
java·ai·技术分享·后端开发
福兮说9 小时前
JSON 格式正确,数据就可靠吗?我用一份自编配置检查类型与空值
java·前端·json
罗西的思考9 小时前
【Agentic RL】Dressage Staleness 控制深度分析
人工智能·算法·机器学习
quaer9 小时前
弗洛伊德算法--判圈法寻找环的入口O(n) O(1)
数据结构·算法
紧跟先前的步伐10 小时前
Go AI Agent 实战 03|Token、上下文窗口与模型调用成本
java·人工智能·golang
文丑颜不良啊11 小时前
LeetCode51~75题目解析
leetcode